<?php

namespace INS_PRO\Controller;

class Admin{
    public function __construct() {
        // add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_admin_scripts' ) );

        // ins License Checked 
        $license_status = apply_filters( 'ins_checked_license_status', false); 
        if (class_exists('INSTANTIO')) {
            if($license_status == false){
                add_action( 'admin_notices', array($this, 'ins_license_deactivate_notice') );
            }
        }
        if (!class_exists('INSTANTIO')) {
            add_action( 'admin_notices', array($this, 'ins_is_instantio') );
        }
  
    }


    public function ins_license_deactivate_notice(){
        $current_user = wp_get_current_user();
        ?>
            <div class="notice notice-warning ins_license_notice"> 
                    
                <?php echo sprintf( 
                        __( ' <p>Hey %1$s 👋, It has come to our attention that although you have successfully installed <b>%2$s</b>, your license has not yet been activated. We kindly request that you activate your license promptly <a href=" %3$s" >here</a>. </p>', 'instantio' ),
                        $current_user->user_login,
                        'Instantio Pro',
                        admin_url().'admin.php?page=ins-license-activation'
                    ); ?> 
                
            </div>
        <?php 
    }
 
    /**
     * Called when Instantio is inactive to display an inactive notice.
     *
     * @since 1.0
     */
    public function ins_is_instantio() {
        if ( current_user_can( 'activate_plugins' ) ) {
            if ( !is_plugin_active( 'instantio/instantio.php' ) && !file_exists( WP_PLUGIN_DIR . '/instantio/instantio.php' ) ) {
            ?>

                <div id="message" class="error">
                    <p><?php printf( __( 'We kindly request that you install and activate Instantio as it is required for our operations. Thank you for your cooperation.', 'instantio' ), '<strong><a href="https://wordpress.org/plugins/instantio/" target="_blank">', '</a></strong>' ); ?></p>
                    <p><a class="install-now button tf-install" data-plugin-slug="instantio"><?php esc_attr_e( 'Install Now', 'instantio' ); ?></a></p>
                </div>

            <?php 
            } elseif ( !is_plugin_active( 'instantio/instantio.php' ) && file_exists( WP_PLUGIN_DIR . '/instantio/instantio.php' ) ) {
            ?>

                <div id="message" class="error">
                    <p><?php printf( __( 'We kindly request that you activate %1$s Instantio %2$s in order to fully utilize its features and capabilities.', 'instantio' ), '<strong><a href="https://wordpress.org/plugins/instantio/" target="_blank">', '</a></strong>' ); ?></p>
                    <p><a href="<?php echo get_admin_url(); ?>plugins.php?_wpnonce=<?php echo wp_create_nonce( 'activate-plugin_instantio/instantio.php' ); ?>&action=activate&plugin=instantio/instantio.php" class="button activate-now button-primary"><?php esc_attr_e( 'Activate', 'instantio' ); ?></a></p>
                </div>

            <?php 
            }
        }
    }

 
}

?>