<?php 
namespace INS_PRO\Controller;

class App {

    public function __construct() { 

        
        if(class_exists('INSTANTIO')){
            // Instantio Pro Includes
             $this->ins_includes_pro();
            if(!empty(insopt('ins-layout')) && insopt('ins-layout') != 'cart'){
                add_filter( 'ins_cart_buttons_pro', array($this, 'ins_cart_buttons_pro'), 9  );  
                add_action( 'ins_template_steps', array($this, 'ins_template_steps')); 
                add_action( 'ins_template_step_content', array($this, 'ins_template_step_content')); 
                add_action( 'ins_login_form', array($this, 'ins_login_form_callback')); 
            } 
        } 

        if(apply_filters( 'ins_checked_license_status', true ) == false){
            return;
        }

        // Instantio Pro Hooks
        add_filter( 'ins_layout_slug', array($this, 'ins_layout_slug'), 9  );
        add_filter( 'ins_get_svg_icon_pro', array($this, 'ins_get_svg_icon_pro'), 9  );
        add_filter( 'ins_layout_class', array($this, 'ins_layout_class_pro'), 9  );
        add_filter( 'ins_cart_template', array($this, 'ins_cart_template'), 9  ); 
        add_action( 'dedicated_mobile_version', array($this, 'dedicated_mobile_version'), 9  );  
        
        add_filter( 'ins_show_items_cross_sell', array($this, 'ins_show_items_cross_sell'), 9  );
        add_filter( 'ins_show_items_upsells', array($this, 'ins_show_items_upsells'), 9  ); 

        add_action( 'wp_ajax_ins_update_order_review_callback', array($this, 'ins_update_order_review_callback'), 10);  
        add_action( 'wp_ajax_nopriv_ins_update_order_review_callback', array($this, 'ins_update_order_review_callback'), 10);  
         
        add_filter('ins_payment_order_summary_contact', array($this, 'ins_payment_order_summary_contact'), 10);
        add_filter('ins_payment_order_shiiping_address', array($this, 'ins_payment_order_shiiping_address'), 10, 4);
        add_filter('ins_payment_order_shiiping_methoods', array($this, 'ins_payment_order_shiiping_methoods'), 10);
        add_filter('ins_payment_order_summery', array($this, 'ins_payment_order_summery'), 10);
        add_filter('ins_payment_order_cart_total', array($this, 'ins_payment_order_cart_total'), 10);
 
        // add_action( 'init', array( $this, 'ins_options_init' ));

    } 

    public function ins_options_init(){ 
        // $license_status = apply_filters( 'ins_checked_license_status', false); 
        // // ins-toggle-panel-tab 
        // echo "<pre>";
        // print_r($license_status); 
        // echo "<pre>";
        // exit();
    }


    public function ins_includes_pro(){
        require_once INS_PRO_INC_PATH . '/controller/icon-svg.php';
    }

    // Custom toggle panel tab Icon Image
    public function ins_get_svg_icon_pro($icon){

        $ins_toggle_icon_choice = isset(insopt('ins-toggle-tab')['wi-icon-choice']) && !empty(insopt('ins-toggle-tab')['wi-icon-choice']) ? insopt('ins-toggle-tab')['wi-icon-choice'] : false;
        $ins_toggle_choice_uploder = isset(insopt('ins-toggle-tab')['wi-icon-choice-uploder']) && !empty(insopt('ins-toggle-tab')['wi-icon-choice-uploder']) ? insopt('ins-toggle-tab')['wi-icon-choice-uploder'] : '';


        if($ins_toggle_icon_choice == true && !empty($ins_toggle_choice_uploder)){
            $icon = '<img src="'.$ins_toggle_choice_uploder.'" alt="icon" />';
        }
        return $icon;
    }
    
    // Change layout class
    public function ins_layout_class_pro($layout_class){

        $ins_layout_mode = !empty(insopt( 'ins-layout-mode' )) ? insopt( 'ins-layout-mode' ) : '';

        $dedicated_mobile = !empty(insopt( 'dedicated_mobile' )) ? insopt( 'dedicated_mobile' ) : false;
        $mobile_cart_panel = !empty(insopt( 'mobile-cart-panel' )) ? insopt( 'mobile-cart-panel' ) : false;
        $dedicated_mobile_panel_class = $dedicated_mobile == true && $mobile_cart_panel == true ? ' ins-dedicated-mobile-card-panel' : '';

        $layout_class .= $dedicated_mobile_panel_class;
        $layout_class .= ' ins-layout-' . $ins_layout_mode;
        return $layout_class; 
    }

    public function dedicated_mobile_version(){
        $dedicated_mobile = !empty(insopt( 'dedicated_mobile' )) ? insopt( 'dedicated_mobile' ) : false;

        $mobile_cart_panel = !empty(insopt( 'mobile-cart-panel' )) ? insopt( 'mobile-cart-panel' ) : false;
        
        if($dedicated_mobile == false && $mobile_cart_panel == false){
            return false;
        }

        $cart_icon = !empty(insopt( 'ins-toggle-tab' )['cart-icon']) ? insopt( 'ins-toggle-tab' )['cart-icon'] : 'shopping-bag';
        $wi_icon_choice = !empty(insopt( 'ins-toggle-tab' )['wi-icon-choice']) ? insopt( 'ins-toggle-tab' )['wi-icon-choice'] : 'icon';
        $wi_icon_choice_uploder = !empty(insopt( 'ins-toggle-tab' )['wi-icon-choice-uploder']) ? insopt( 'ins-toggle-tab' )['wi-icon-choice-uploder'] : '';
        if($cart_icon == 'shopping-bag'){

            $toggle_icon = apply_filters( 'ins_get_svg_icon_pro', instantio_svg_icon($cart_icon) ); 
        }else{
            $toggle_icon = '<i class="'.$cart_icon.'"></i>';
        }
        if($wi_icon_choice == 'image' && $wi_icon_choice_uploder !=''){
            $toggle_icon = '<img src="'.$wi_icon_choice_uploder.'" alt="Icon Image">';
        }
        
        ob_start();
        ?>
        <div class="ins-mobile-bar">
            <div class="ins-mobie-bar_icon">
                <?php echo $toggle_icon ?>
                <span class="ins-items-count"><span id="ins_cart_totals" class="ins_cart_total"><?php echo WC()->cart->get_cart_contents_count(); ?></span></span>
            </div>
            <div class="ins-mobile-cart-total">
                <span><?php _e('Cart Total', 'instantio') ?> <br> <strong>  
                    <span id="ins-mobile-cart-total-amount"><?php echo WC()->cart->get_cart_total(); ?></span>
                </strong></span>
            </div>
            <div class="ins-mobile-cart-btn ins-cart-btns">
                <a href="<?php echo esc_url(wc_get_checkout_url());  ?>" class="ins-mobile-checkout" data-step-prev="step-1" data-step-content="shipping">Checkout</a>
            </div>
        </div>
        <?php

        echo ob_get_clean();
    }

    public function ins_show_items_cross_sell($html) {
        $crosssell = !empty(insopt( 'crosssell' )) ? insopt( 'crosssell' ) : false;
        if($crosssell == false){
            return $html;
        }
    
        ob_start();
        // require_once INS_PRO_INC_PATH . '/templates/cross-sell.php';
        $limit = 2; $columns = 2; $orderby = 'rand'; $order = 'desc';
        // Get visible cross sells then sort them at random.
        $cross_sells = array_filter( array_map( 'wc_get_product', WC()->cart->get_cross_sells() ), 'wc_products_array_filter_visible' ); 

        // Handle orderby and limit results.
        $orderby     = apply_filters( 'woocommerce_cross_sells_orderby', $orderby );
        $order       = apply_filters( 'woocommerce_cross_sells_order', $order );
        $cross_sells = wc_products_array_orderby( $cross_sells, $orderby, $order );
        $limit       = apply_filters( 'woocommerce_cross_sells_total', $limit );
        $cross_sells = $limit > 0 ? array_slice( $cross_sells, 0, $limit ) : $cross_sells;
    
        // default path (look in plugin file!)
        $default_path = untrailingslashit( INS_PRO_INC_PATH ) . '/templates/';
        wc_get_template(
            'cross-sells.php',
            array(
                'cross_sells'    => $cross_sells,

                // Not used now, but used in previous version of up-sells.php.
                'posts_per_page' => $limit,
                'orderby'        => $orderby,
                'columns'        => $columns,
            ), '', $default_path 
        );  
        return ob_get_clean();
    }

    // Show items upsells
    public function ins_show_items_upsells($html) {

        $limit = '-1'; $columns = 3; $orderby = 'rand'; $order = 'desc';  
        $cart  = WC()->cart;  
        $upsell_ids = $cart_item_ids = array(); 
        // Loop through cart items
        foreach( $cart->get_cart() as $cart_item ) { 
            // Merge all cart items upsells ids
            $upsell_ids      = array_merge( $upsell_ids, $cart_item['data']->get_upsell_ids() );
            $cart_item_ids[] = $cart_item['product_id'];
        }
        
        // Remove cart item ids from upsells
        $upsell_ids = array_diff($upsell_ids, $cart_item_ids);
        $upsell_ids = array_unique($upsell_ids); // Remove duplicated Ids
        
        // Handle the legacy filter which controlled posts per page etc.
        $args = apply_filters( 'woocommerce_upsell_display_args', array(
            'posts_per_page' => $limit,
            'orderby'        => $orderby,
            'order'          => $order,
            'columns'        => $columns,
        ));
         

        $orderby = apply_filters( 'woocommerce_upsells_orderby', isset( $args['orderby'] ) ? $args['orderby'] : $orderby );
        $_order  = apply_filters( 'woocommerce_upsells_order', isset( $args['order'] ) ? $args['order'] : $order );
        $limit   = apply_filters( 'woocommerce_upsells_total', isset( $args['posts_per_page'] ) ? $args['posts_per_page'] : $limit );
        
        // Get visible upsells then sort them at random, then limit result set.
        $upsells = wc_products_array_orderby( array_filter( array_map( 'wc_get_product', $upsell_ids ), 'wc_products_array_filter_visible' ), $orderby, $_order );
        $upsells = $limit > 0 ? array_slice( $upsells, 0, $limit ) : $upsells;

        // default path (look in plugin file!)
        $default_path = untrailingslashit( INS_PRO_INC_PATH ) . '/templates/';
        wc_get_template( 'up-sells.php', array(
            'upsells'        => $upsells,

            // Not used now, but used in previous version of up-sells.php.
            'posts_per_page' => $limit,
            'orderby'        => $orderby,
            'columns'        => $columns,
        ), '', $default_path );
    }

    // Change layout slug
    public function ins_layout_slug($slug){
        
        $ins_single_layout = !empty(insopt( 'ins-layout-step' )) ? insopt( 'ins-layout-step' ) : false;
        if($ins_single_layout == true){
           $slug =  INS_PRO_TEMPLATES_PATH . '/single-step.php';
        }
        return $slug;
    }
    // Change cart template
    public function ins_cart_template($template){
        return $template;
    }

    // Add Checkout Steps
    public function ins_template_steps(){  
        require_once INS_PRO_INC_PATH . '/templates/progress.php';
    }

    // Add Checkout Steps Content
    public function ins_template_step_content(){
        require_once INS_PRO_INC_PATH . '/templates/form-checkout.php';
    }
    
    // Change cart toggle button
    public function ins_cart_buttons_pro($button){
        ob_start();
        ?>
        <div class="ins-cart-btns"> 
            <button class="ins-btns-step-next checkout" data-step-prev="step-1" data-step-content="shipping"> Proceed to checkout </button>
        </div>  
        <?php 
        $button = ob_get_clean();
        return $button;
    } 

    public function ins_login_form_callback(){
        if ( is_user_logged_in() || 'no' === get_option( 'woocommerce_enable_checkout_login_reminder' ) ) {
            return;
        }
        ?>
        <div class="ins-cart-inner ins-login-form-inner shipping ins-text-left">
            <div class="ins-delivery-wrap">
                <div class="ins-order-summery-head">  
                    <span>Returning customer? <a href="#" class="ins-showlogin"><?php _e('Click here to login', 'instantio') ?></a></span> 
                </div> 
                <div class="ins-cart-content-wrap ins-login-form ins-text-left">
                    <?php
                        
                        woocommerce_login_form(
                            array(
                                'message'  => esc_html__( 'If you have shopped with us before, please enter your details below. If you are a new customer, please proceed to the Billing section.', 'woocommerce' ),
                                'redirect' => get_site_url() . $_SERVER['REQUEST_URI'],
                                'hidden'   => true,
                            )
                        );
                    ?>
                </div>
            
            </div> 
        </div> 
        <?php
         
    }

    // Ins payment Order summary Action Hook
    public function ins_payment_order_summary_contact($email){
        ob_start();
        ?>
         <div class="ins-order-summery-head"> 
            <h3><?php echo esc_html_e( 'Contact', 'woocommerce' ) ?> </h3>
            <a href="#" class="ins-back-to-edit" data-step-prev= "step-1"   data-step-content = "shipping"> 
                <svg width="16" height="16" viewBox="0 0 16 16" fill="none" xmlns="http://www.w3.org/2000/svg">
                    <path d="M2.16667 13.8334H3.345L11.1067 6.07174L9.92833 4.8934L2.16667 12.6551V13.8334ZM15.5 15.5001H0.5V11.9642L11.6958 0.768403C11.8521 0.612177 12.064 0.524414 12.285 0.524414C12.506 0.524414 12.7179 0.612177 12.8742 0.768403L15.2317 3.1259C15.3879 3.28218 15.4757 3.4941 15.4757 3.71507C15.4757 3.93604 15.3879 4.14796 15.2317 4.30424L5.7025 13.8334H15.5V15.5001ZM11.1067 3.71507L12.285 4.8934L13.4633 3.71507L12.285 2.53674L11.1067 3.71507Z" fill="#4D423D"/>
                </svg>
            </a>
        </div>
        <p>  <?php echo $email ?></p>
        <hr>
        <?php
        return ob_get_clean();
    }

    // ins Payment Shipping Address 
    public function ins_payment_order_shiiping_address($first_name, $last_name, $billing_phone, $shipping_address){
        ob_start();
        ?>
            <div class="ins-order-summery-head"> 
                <h3><?php echo esc_html_e( 'Shipping address', 'woocommerce' ) ?> </h3>
                <a href="#" class="ins-back-to-edit" data-step-prev= "step-1"   data-step-content = "shipping" > 
                    <svg width="16" height="16" viewBox="0 0 16 16" fill="none" xmlns="http://www.w3.org/2000/svg">
                        <path d="M2.16667 13.8334H3.345L11.1067 6.07174L9.92833 4.8934L2.16667 12.6551V13.8334ZM15.5 15.5001H0.5V11.9642L11.6958 0.768403C11.8521 0.612177 12.064 0.524414 12.285 0.524414C12.506 0.524414 12.7179 0.612177 12.8742 0.768403L15.2317 3.1259C15.3879 3.28218 15.4757 3.4941 15.4757 3.71507C15.4757 3.93604 15.3879 4.14796 15.2317 4.30424L5.7025 13.8334H15.5V15.5001ZM11.1067 3.71507L12.285 4.8934L13.4633 3.71507L12.285 2.53674L11.1067 3.71507Z" fill="#4D423D"/>
                    </svg>
                </a>
            </div>
            <span><strong><?php echo esc_html_e( 'Name:', 'woocommerce' ) ?> <?php echo esc_attr( $first_name ) ?> <?php echo esc_attr( $last_name ) ?></strong></span> <br>
            <span><strong><?php echo esc_html_e( 'Phone:', 'woocommerce' ) ?> <?php echo esc_attr( $billing_phone ) ?></strong></span> <br>
            <span>  <?php echo $shipping_address ?></span> <br> <br>
            <hr>
        <?php 
        return ob_get_clean(); 
    }
    

    // ins Payment Shipping Methoods
    public function ins_payment_order_shiiping_methoods(){
        ob_start();
        if ( WC()->cart->needs_shipping() && WC()->cart->show_shipping() ) {
            ?><h3><?php esc_html_e( 'Delivery charge', 'woocommerce' ); ?> </h3> <?php
            do_action( 'woocommerce_review_order_before_shipping' );
            wc_cart_totals_shipping_html();
            do_action( 'woocommerce_review_order_after_shipping' );
        }
        return ob_get_clean();
    }
 
    // ins Payment Order Summary
    public function ins_payment_order_summery(){
        ob_start();
        do_action( 'woocommerce_review_order_before_cart_contents' );

        foreach ( WC()->cart->get_cart() as $cart_item_key => $cart_item ) {
            $_product = apply_filters( 'woocommerce_cart_item_product', $cart_item['data'], $cart_item, $cart_item_key );

            if ( $_product && $_product->exists() && $cart_item['quantity'] > 0 && apply_filters( 'woocommerce_checkout_cart_item_visible', true, $cart_item, $cart_item_key ) ) {
                $product_permalink = apply_filters( 'woocommerce_cart_item_permalink', $_product->is_visible() ? $_product->get_permalink( $cart_item ) : '', $cart_item, $cart_item_key );
    
                ?>
                <div class="ins-single-order-summery <?php echo esc_attr( apply_filters( 'woocommerce_cart_item_class', 'cart_item', $cart_item, $cart_item_key ) ); ?>">
                    <div class="ins-order-summery-img"> 
                    <?php
                        $thumbnail = apply_filters( 'woocommerce_cart_item_thumbnail', $_product->get_image(), $cart_item, $cart_item_key );

                        if ( ! $product_permalink ) {
                            echo $thumbnail; // PHPCS: XSS ok.
                        } else {
                            printf( '<a href="%s">%s</a>', esc_url( $product_permalink ), $thumbnail ); // PHPCS: XSS ok.
                        }
                    ?> 
                    </div>
                    <div class="ins-order-summery-content"> 
                        <span class="product-title"><?php echo wp_kses_post( apply_filters( 'woocommerce_cart_item_name', $_product->get_name(), $cart_item, $cart_item_key ) ) . '&nbsp;'; ?></span>
                        <span class="ins-order-summery-qty">
                                <?php echo apply_filters( 'woocommerce_checkout_cart_item_quantity', ' <strong class="product-quantity">' . sprintf( '&times;&nbsp;%s', $cart_item['quantity'] ) . '</strong>', $cart_item, $cart_item_key );  ?> 
                        </span>
                        <span class="ins-order-summery-price">
                            <?php echo apply_filters( 'woocommerce_cart_item_subtotal', WC()->cart->get_product_subtotal( $_product, $cart_item['quantity'] ), $cart_item, $cart_item_key );  ?>
                        </span> 
                    </div>
                </div> 
                <?php
            }
        }

        do_action( 'woocommerce_review_order_after_cart_contents' );
        return ob_get_clean();
    }

    // ins Payment Order Total
    public function ins_payment_order_cart_total(){
        ob_start();
        ?>
            <div class= "ins-single-order-total">
                <span class="ins-total-title"><?php esc_html_e( 'Subtotal', 'woocommerce' ); ?></span>
                <span><?php wc_cart_totals_subtotal_html(); ?></span>
            </div>
            
            <?php foreach ( WC()->cart->get_coupons() as $code => $coupon ) : ?>
                <div class= "ins-single-order-total cart-discount coupon-<?php echo esc_attr( sanitize_title( $code ) ); ?>">
                    <span class="ins-total-title"><?php wc_cart_totals_coupon_label( $coupon ); ?></span>
                    <span><?php wc_cart_totals_coupon_html( $coupon ); ?></span>
                </div> 
            <?php endforeach; ?>
            
            <?php foreach ( WC()->cart->get_fees() as $fee ) : ?>
                <div class= "ins-single-order-total fee">
                    <span class="ins-total-title "><?php echo esc_html( $fee->name ); ?> </span>
                    <span><?php wc_cart_totals_fee_html( $fee ); ?></span>
                </div> 
            <?php endforeach; ?>
            <?php if ( wc_tax_enabled() && ! WC()->cart->display_prices_including_tax() ) : ?>
                <?php if ( 'itemized' === get_option( 'woocommerce_tax_total_display' ) ) : ?>
                    <?php foreach ( WC()->cart->get_tax_totals() as $code => $tax ) : // phpcs:ignore WordPress.WP.GlobalVariablesOverride.Prohibited ?>
                        <div class= "ins-single-order-total tax-rate tax-rate-<?php echo esc_attr( sanitize_title( $code ) ); ?>">
                            <span class="ins-total-title "><?php echo esc_html( $tax->label ); ?></span>
                            <span><?php echo wp_kses_post( $tax->formatted_amount ); ?></span>
                        </div> 
                    <?php endforeach; ?>
                <?php else : ?>
                    <div class= "ins-single-order-total tax-total">
                        <span class="ins-total-title "><?php echo esc_html( WC()->countries->tax_or_vat() ); ?></span>
                        <span><?php wc_cart_totals_taxes_total_html(); ?></span>
                    </div>  
                <?php endif; ?>
            <?php endif; ?>
            <div class= "ins-single-order-total total order-total">
                <span class="ins-total-title "><?php esc_html_e( 'Total', 'woocommerce' ); ?></span>
                <span><?php wc_cart_totals_order_total_html(); ?></span>
            </div>
        <?php
        return ob_get_clean();
    }

    // ins Payment Order Review
    public function ins_update_order_review_callback() {
        $fields = json_decode( stripslashes( $_REQUEST['fields'] ), true );
        if( !empty($fields) ){
            $email = $fields['billing_email'];
            $first_name = $fields['billing_first_name'];
            $last_name = $fields['billing_last_name'];
            $billing_phone = $fields['billing_phone'];
           if( in_array('ship_to_different_address', $fields) && $fields['ship_to_different_address'] == 'true' ){
                $shipping_address = $fields['shipping_address_1'] . ', ' . $fields['shipping_address_2']. ', ' . $fields['shipping_city']. ', ' . $fields['shipping_state']. ', ' . $fields['shipping_postcode']. ', ' . $fields['shipping_country'];
            }else{
                $shipping_address = $fields['billing_address_1'] . ', ' . $fields['billing_address_2']. ', ' . $fields['billing_city']. ', ' . $fields['billing_state']. ', ' . $fields['billing_postcode']. ', ' . $fields['billing_country'];
            }
        }
        
        // $fields = $_POST['fields'];
        // Get the updated cart totals and shipping methods
        WC()->cart->calculate_shipping();
        WC()->cart->calculate_totals();
        $cart_totals = WC()->cart->get_totals();
        $available_shipping_methods = WC()->shipping()->get_shipping_methods(); 
        
        // ins contact
        $ins_contact = apply_filters( 'ins_payment_order_summary_contact',$email ); 
        
        // ins shipping address
        $ins_shiiping = apply_filters( 'ins_payment_order_shiiping_address', $first_name, $last_name, $billing_phone, $shipping_address ); 
  
        // ins shipping details
        $ins_shipping_details = apply_filters( 'ins_payment_order_shiiping_methoods', '' );

        // ins order summery 
        $ins_order_summery = apply_filters( 'ins_payment_order_summery', '' );
        
        // Ins Cart Total
        $ins_order_total = apply_filters( 'ins_payment_order_cart_total', '' ); 

        // Ins CrossSell
        $cross_sells = apply_filters( 'ins_show_items_cross_sell', '' ); 

        $response = array(
            'ins_contact' => $ins_contact,
            'ins_shiiping' => $ins_shiiping, 
            'ins_shipping_details' => $ins_shipping_details, 
            'ins_order_summery' => $ins_order_summery, 
            'ins_order_total' => $ins_order_total, 
            'cross_sells' => $cross_sells, 
        );
        wp_send_json_success( $response );
        wp_die();
    }

 
}



?>